/*
   digraph.h
   San Skulrattanakulchai
   11/11/99
 */
#ifndef DIGRAPH_H
#define DIGRAPH_H

#include "util.h"

typedef int Vertex;

typedef struct node {
  Vertex vertex;
  struct node *next;
} Node, *NodePtr;

/* both the digraph and its reverse are kept in this struct */
typedef struct {
  int n;
  int m;
  NodePtr *adj;   /* adjacency lists */
  NodePtr *radj;  /* adjacency lists for the reverse digraph */
} Digraph, *DigraphPtr;

/* make an empty digraph having ord vertices */
#define makeEmptyDigraph(ord, Gp)\
{\
  mallocOrDie(sizeof(Digraph), (Gp));\
  (Gp)->n = (ord);\
  (Gp)->m = 0;\
  callocOrDie((ord)+1, sizeof(NodePtr), (Gp)->adj);\
  callocOrDie((ord)+1, sizeof(NodePtr), (Gp)->radj);\
}

/*
  add edge (v,w) to the front of the adjacency list of v
  add edge (w,v) to the front of the reverse adjacency list of w
 */
#define addEdge(v, w, Gp)\
{\
  NodePtr np;\
  mallocOrDie(sizeof(Node), np);\
  np->vertex = (w);\
  np->next = (Gp)->adj[(v)];\
  (Gp)->adj[(v)] = np;\
  mallocOrDie(sizeof(Node), np);\
  np->vertex = (v);\
  np->next = (Gp)->radj[(w)];\
  (Gp)->radj[(w)] = np;\
  ((Gp)->m)++;\
}

void deleteAdjList(NodePtr);
void deleteDigraph(DigraphPtr);

#endif
