/*
   hcube.c
   San Skulrattanakulchai
   11/11/99
 */
#include "digraph.h"
#include "gen.h"
#include "random.h"

/*
   Generate a random oriented hypercube.
 */
DigraphPtr hcube(int d, int nv, bool oriented)
{
  DigraphPtr Gp;
  Vertex v, w;
  int j;
  unsigned i, mask;

  makeEmptyDigraph(nv, Gp);

  for (i = 0; i < nv; i++) {
    v = i + 1;
    mask = 1;
    for (j = 1; j <= d; j++) {
      w = (i ^ mask) + 1;
      if (oriented && v < w) {
        if (coinFlip()) {
          addEdge(v, w, Gp);
        } else {
          addEdge(w, v, Gp);
        }
      } else if (!oriented && coinFlip())
        addEdge(v, w, Gp);
      mask <<= 1;
    }
  }

  return Gp;
}
