/*
   thard.c
   San Skulrattanakulchai
   11/11/99
 */
#include "digraph.h"
#include "gen.h"

/*
  Generate a digraph of nv vertices that is hard for Tarjan's LOWLINK alg.
  Family 1.
 */
DigraphPtr thard1(int nv)
{
  DigraphPtr Gp;
  Vertex v, w;

  makeEmptyDigraph(nv, Gp);

  for (w = nv; w >= nv/2+1; w--)
    addEdge(1, w, Gp);

  for (v = 1; v <= nv/2 - 1; v++)
    addEdge(v, v+1, Gp);
  addEdge(nv/2, 1, Gp);

  for (v = nv/2 + 1; v <= nv; v++)
    for (w = 1; w <= nv/2; w++) 
      addEdge(v, w, Gp);

  return Gp;
}

/*
   Generate a digraph of nv vertices that is hard for Tarjan's LOWLINK alg.
   Family 2.
 */
DigraphPtr thard2(int nv)
{
  DigraphPtr Gp;
  Vertex v, w;

  makeEmptyDigraph(nv, Gp);

  for (w = nv; w >= 2; w--)
    addEdge(1, w, Gp);

  for (v = 2; v <= nv; v++)
    for (w = 1; w < v; w++) 
      addEdge(v, w, Gp);

  return Gp;
}
